/*
***********************************************************************
LICENSE AGREEMENT
***********************************************************************
 READ THIS LICENSE AGREEMENT CAREFULLY BEFORE USING THIS PRODUCT. BY 
 USING THIS PRODUCT YOU INDICATE YOUR ACCEPTANCE OF THE TERMS OF THE 
 FOLLOWING AGREEMENT. THESE TERMS APPLY TO YOU AND ANY SUBSEQUENT 
 LICENSEE OF THIS PRODUCT.

               License Agreement for RegularPlace 1.0

Copyright (c)  2008 by 
Ashutosh Chakraborty, Anurag Kumar, David Z. Pan
All rights reserved

ATTRIBUTION ASSURANCE LICENSE
Redistribution of the any code, with or without modification, are permitted 
provided that the conditions below are met. These conditions require a 
modest attribution to Ashutosh Chakraborty, Anurag Kumar and Dr. 
David Z. Pan (the "Author").

1. Redistributions of any code, with or without modification (the "Code"), 
must be accompanied by any documentation and, each time the resulting 
executable program or a program dependent thereon is launched, a 
prominent display (e.g., splash screen or banner text) of the Author's 
attribution information, which includes:
  (a) Ashutosh Chakraborty, Anurag Kumar, and Dr. David Z. Pan ("AUTHOR"),
  (b) The University of Texas at Austin ("PROFESSIONAL IDENTIFICATION"), and
  (c) http://www.cerc.utexas.edu/utda/ ("URL").

2. Use is limited to academic research groups only. Users who are interested 
in industry or commercial purposes must notify Author and request 
separate license agreement.  

3. Neither the name nor any trademark of the Author may be used to 
endorse or promote products derived from this software without specific 
prior written permission.

4. Users are entirely responsible, to the exclusion of the Author and 
any other persons, for compliance with (a) regulations set by owners or 
administrators of employed equipment, (b) licensing terms of any other 
software, and (c) local, national, and international regulations regarding 
use, including those regarding import, export, and use of encryption software. 

THIS FREE SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE AUTHOR OR ANY CONTRIBUTOR BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, EFFECTS OF UNAUTHORIZED OR MALICIOUS NETWORK 
ACCESS; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY 
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#include "Grid.h"
// #include "Net.h"
#include "Design.h"

CGrid::CGrid(void)
{
//  m_iState = STATE_NULL;
//  m_iBCount = 0;
//  m_iUsed= 0;
//
//  memset(m_pPGrid,0x00,sizeof(CGrid*)*(MAX_NEIGHBOR_GRID+1));
//  SetState(STATE_MAZE_VOID);
}

CGrid::~CGrid(void)
{
}

// void CGrid::Block()
// {
//  if(m_iBCount==0)
//  {
//   SetState(STATE_GRID_BLOCK);
//  }
//
//  ++m_iBCount;
// }


// void CGrid::Unblock()
// {
//  --m_iBCount;
//  if(m_iBCount==0)
//  {
//   SetState(~STATE_GRID_BLOCK);
//  }
// }




#if 0

void CGrid::Initialize(int iX, int iY)
{
  m_iX = iX;
  m_iY = iY;
  m_iT = 0;
  m_iSteinerState = 0;
  int iIndex = 0;

  m_pNGrid[iIndex] = CDesign::GetDesign()->GetPGrid(m_iX - 1, m_iY);
  if (m_pNGrid[iIndex]) ++iIndex;

  m_pNGrid[iIndex] = CDesign::GetDesign()->GetPGrid(m_iX, m_iY - 1);
  if (m_pNGrid[iIndex]) ++iIndex;

  m_pNGrid[iIndex] = CDesign::GetDesign()->GetPGrid(m_iX + 1, m_iY);
  if (m_pNGrid[iIndex]) ++iIndex;

  m_pNGrid[iIndex] = CDesign::GetDesign()->GetPGrid(m_iX, m_iY + 1);
//     SetSteinerState(0);
  m_pNGrid[iIndex+1] = NULL;
}


void CGrid::SetState(int iState)
{
  switch (iState)
  {
  case ~STATE_GRID_DROPLET:
    assert(m_Owner.size() == 1);
    assert(m_iState&STATE_GRID_DROPLET);
    assert(!(m_iState&STATE_GRID_BLOCK));
    m_iState &= ~STATE_GRID_DROPLET;
    break;
  case STATE_GRID_DROPLET:
    assert(m_Owner.size() == 1);
    assert(m_iState&STATE_GRID_SHADED);
    assert(!(m_iState&STATE_GRID_DROPLET));
    assert(!(m_iState&STATE_GRID_BLOCK));
    m_iState |= STATE_GRID_DROPLET;
    break;
  case ~STATE_GRID_BLOCK:
    m_iState &= ~STATE_GRID_BLOCK;
    break;
  case STATE_GRID_BLOCK:
    m_iState |= STATE_GRID_BLOCK;
    break;
  case STATE_GRID_SHADED:

    assert(!(m_iState&STATE_GRID_BLOCK));
    m_iState |= STATE_GRID_SHADED;
    //assert(m_iShadeCount>=0);
    //m_iShadeCount++;
    //if(m_iShadeCount==1) m_iBCost += MAX_BUSY;
    //else     m_iBCost++;
    //assert(m_iBCost<2*MAX_BUSY);
    break;
  case ~STATE_GRID_SHADED:
    if (m_Owner.size() == 0)
      m_iState &= ~STATE_GRID_SHADED;

    //m_iShadeCount--;
    //assert(m_iShadeCount>=0);
    //if(m_iShadeCount==0)
    //{
    // m_iBCost -= MAX_BUSY;
    // assert(m_iBCost<MAX_BUSY);
    // m_iState &= ~STATE_GRID_SHADED;
    //}
    //else m_iBCost = MAX(MAX_BUSY,m_iBCost-1);
    break;
  case STATE_MAZE_SOURCE:
    m_iState &= 0x0FFFFFFF;
    m_iState |= STATE_MAZE_SOURCE;
    break;
  case STATE_MAZE_TARGET:
    m_iState &= 0x0FFFFFFF;
    m_iState |= STATE_MAZE_TARGET;
    break;
  case STATE_MAZE_VOID:
    m_iState &= 0x0FFFFFFF;
    m_iState |= STATE_MAZE_VOID;
    m_iHeapPos = -1;
    m_iRCost = 0;
    m_iPCost = 0;
    m_iTCost = 0;
    break;
  case STATE_MAZE_FLOODED:
    m_iState &= 0x0FFFFFFF;
    m_iState |= STATE_MAZE_FLOODED;
    break;
  case STATE_STEINER_GRID_OCCUPIED:
    m_iState    &=  0xF0FFFFFF;
    m_iState    |=  STATE_STEINER_GRID_OCCUPIED;
    break;
  case ~STATE_STEINER_GRID_OCCUPIED:
    m_iState    &=  0xF0FFFFFF;
    m_iState    |=  ~STATE_STEINER_GRID_OCCUPIED;
    break;
  default:
    assert(false);
    break;
  }

#ifdef _DEBUG
  if ((m_iState&STATE_MAZE_TARGET && m_iState&STATE_MAZE_FLOODED))
  {
    assert(!(m_iState&STATE_MAZE_TARGET && m_iState&STATE_MAZE_FLOODED));
    assert(!(m_iState&STATE_MAZE_SOURCE && m_iState&STATE_MAZE_FLOODED));
    assert(!(m_iState&STATE_MAZE_SOURCE && m_iState&STATE_MAZE_TARGET));
  }


#endif
}

int CGrid::GetHeapCost()
{
  return m_iRCost + m_iPCost;
}

int CGrid::GetDistance(int iX, int iY)
{
  return abs(iX -m_iX) + abs(iY - m_iY);
}

int CGrid::GetDistance(CGrid* pGrid)
{
  return GetDistance(pGrid->m_iX, pGrid->m_iY);
}

int CGrid::GetDistance3D(CGrid* pGrid)
{
  return GetDistance(pGrid->m_iX, pGrid->m_iY) + abs(m_iT - pGrid->m_iT);
}

int CGrid::IsVertical(CGrid* pGrid)
{
  return pGrid->m_iX == m_iX;
}

int CGrid::IsHorizontal(CGrid* pGrid)
{
  return pGrid->m_iY == m_iY;
}

void CGrid::AddOwner(CNet* pNet)
{
#ifdef _DEBUG
  if (pNet->m_iIndex == 2 &&
      m_iX == 0 && m_iY == 2 && m_iT == 169)
  {
    int a = 0;
  }
#endif
  DelOwner(pNet);
  m_Owner.push_back(pNet);
  SetState(STATE_GRID_SHADED);
#ifdef _DEBUG
  if (m_iState&STATE_GRID_DROPLET)
  {
    assert(m_iState&STATE_GRID_SHADED);
    assert(m_Owner.size() == 1);
  }
#else
  //if(m_iState&STATE_GRID_DROPLET)
  //{
  // if(m_Owner.size()!=1)
  // {
  //  printf("error!\n");exit(0);
  // }
  //}

#endif
  assert(FindOwner(pNet) == 1);
}

int CGrid::FindOwner(CNet* pNet)
{
  int iCount = 0;
  for (vector<CNet*>::iterator itr = m_Owner.begin(), end = m_Owner.end();itr != end;++itr)
  {
    if (*itr == pNet) ++iCount;
  }

  return iCount;
}

void CGrid::DelOwner(CNet* pNet)
{
  for (vector<CNet*>::iterator itr = m_Owner.begin(), end = m_Owner.end();itr != end;++itr)
  {
    if (*itr == pNet)
    {
      m_Owner.erase(itr);
      SetState(~STATE_GRID_SHADED);
      return;
    }
  }
}

#endif
