/*
***********************************************************************
LICENSE AGREEMENT
***********************************************************************
 READ THIS LICENSE AGREEMENT CAREFULLY BEFORE USING THIS PRODUCT. BY 
 USING THIS PRODUCT YOU INDICATE YOUR ACCEPTANCE OF THE TERMS OF THE 
 FOLLOWING AGREEMENT. THESE TERMS APPLY TO YOU AND ANY SUBSEQUENT 
 LICENSEE OF THIS PRODUCT.

               License Agreement for RegularPlace 1.0

Copyright (c)  2008 by 
Ashutosh Chakraborty, Anurag Kumar, David Z. Pan
All rights reserved

ATTRIBUTION ASSURANCE LICENSE
Redistribution of the any code, with or without modification, are permitted 
provided that the conditions below are met. These conditions require a 
modest attribution to Ashutosh Chakraborty, Anurag Kumar and Dr. 
David Z. Pan (the "Author").

1. Redistributions of any code, with or without modification (the "Code"), 
must be accompanied by any documentation and, each time the resulting 
executable program or a program dependent thereon is launched, a 
prominent display (e.g., splash screen or banner text) of the Author's 
attribution information, which includes:
  (a) Ashutosh Chakraborty, Anurag Kumar, and Dr. David Z. Pan ("AUTHOR"),
  (b) The University of Texas at Austin ("PROFESSIONAL IDENTIFICATION"), and
  (c) http://www.cerc.utexas.edu/utda/ ("URL").

2. Use is limited to academic research groups only. Users who are interested 
in industry or commercial purposes must notify Author and request 
separate license agreement.  

3. Neither the name nor any trademark of the Author may be used to 
endorse or promote products derived from this software without specific 
prior written permission.

4. Users are entirely responsible, to the exclusion of the Author and 
any other persons, for compliance with (a) regulations set by owners or 
administrators of employed equipment, (b) licensing terms of any other 
software, and (c) local, national, and international regulations regarding 
use, including those regarding import, export, and use of encryption software. 

THIS FREE SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE AUTHOR OR ANY CONTRIBUTOR BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, EFFECTS OF UNAUTHORIZED OR MALICIOUS NETWORK 
ACCESS; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY 
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
*/

/*
 * =======================================================================
 *
 *       Filename:  Tile.hxx
 *
 *    Description:  Tiles description
 *
 *        Version:  1.0
 *        Created:  10/01/2008 11:58:41 AM CDT
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ashutosh Chakraborty (), ashutosh@mail.utexas.edu
 *        Company:  University of Texas, Austin
 *
 * =======================================================================
 */

#ifndef _CTILE_H
#define _CTILE_H

class CNode;
static const int gNumColmnPerTile = 24;
static const int gMaxColmHeight = 64;
extern bool cmpNodes(const CNode *a, const CNode *b);

class InfoAt
{
  public:
    bool isOccupied;
    int  cellType;
    CNode *n;
  public:
    InfoAt() : n(NULL), isOccupied(false), cellType(-1) {}
};

class CTile
{
  private:
    static map <int, int> mMapInitXOfECellColm;
    static map <int, int> sEDMapXToColmNum;
    static map <int, int> mMapInitXOfDffColm;
    static map <int, int> sECMapXToColmNum;

  public:
    CTile(double xOff, double yOff)
        : mIsLegal(false), mIsDirty(true), mX(xOff), mY(yOff)
    {
      mECells.clear();
      mDffs.clear();
      mRegs.clear();
      mBrams.clear();
      mNumCellsOfClk.clear();

      mColumnsEDff.resize(24);
      mColumnsECell.resize(36);

      vecBool.resize(92);
      for (int i=0; i<vecBool.size(); i++)
        vecBool[i].resize(64);

      static bool firstTime = true;

      if (true == firstTime)
      {
        firstTime = false;

        mMapInitXOfDffColm[0] = 0;
        mMapInitXOfDffColm[1] = 4;
        mMapInitXOfDffColm[2] = 5;
        mMapInitXOfDffColm[3] = 9;
        mMapInitXOfDffColm[4] = 10;
        mMapInitXOfDffColm[5] = 14;
        mMapInitXOfDffColm[6] = 15;
        mMapInitXOfDffColm[7] = 19;
        mMapInitXOfDffColm[8] = 20;
        mMapInitXOfDffColm[9] = 24;
        mMapInitXOfDffColm[10] = 25;
        mMapInitXOfDffColm[11] = 29;
        mMapInitXOfDffColm[12] = 46;
        mMapInitXOfDffColm[13] = 50;
        mMapInitXOfDffColm[14] = 51;
        mMapInitXOfDffColm[15] = 55;
        mMapInitXOfDffColm[16] = 56;
        mMapInitXOfDffColm[17] = 60;
        mMapInitXOfDffColm[18] = 61;
        mMapInitXOfDffColm[19] = 65;
        mMapInitXOfDffColm[20] = 66;
        mMapInitXOfDffColm[21] = 70;
        mMapInitXOfDffColm[22] = 71;
        mMapInitXOfDffColm[23] = 75;

        sEDMapXToColmNum[0]  = 0;
        sEDMapXToColmNum[4]  = 1;
        sEDMapXToColmNum[5]  = 2;
        sEDMapXToColmNum[9]  = 3;
        sEDMapXToColmNum[10] = 4;
        sEDMapXToColmNum[14] = 5;
        sEDMapXToColmNum[15] = 6;
        sEDMapXToColmNum[19] = 7;
        sEDMapXToColmNum[20] = 8;
        sEDMapXToColmNum[24] = 9;
        sEDMapXToColmNum[25] = 10;
        sEDMapXToColmNum[29] = 11;
        sEDMapXToColmNum[46] = 12;
        sEDMapXToColmNum[50] = 13;
        sEDMapXToColmNum[51] = 14;
        sEDMapXToColmNum[55] = 15;
        sEDMapXToColmNum[56] = 16;
        sEDMapXToColmNum[60] = 17;
        sEDMapXToColmNum[61] = 18;
        sEDMapXToColmNum[65] = 19;
        sEDMapXToColmNum[66] = 20;
        sEDMapXToColmNum[70] = 21;
        sEDMapXToColmNum[71] = 22;
        sEDMapXToColmNum[75] = 23;

        mMapInitXOfECellColm[0] = 1;
        mMapInitXOfECellColm[1] = 2;
        mMapInitXOfECellColm[2] = 3;
        mMapInitXOfECellColm[3] = 6;
        mMapInitXOfECellColm[4] = 7;
        mMapInitXOfECellColm[5] = 8;
        mMapInitXOfECellColm[6] = 11;
        mMapInitXOfECellColm[7] = 12;
        mMapInitXOfECellColm[8] = 13;
        mMapInitXOfECellColm[9] = 16;
        mMapInitXOfECellColm[10] = 17;
        mMapInitXOfECellColm[11] = 18;
        mMapInitXOfECellColm[12] = 21;
        mMapInitXOfECellColm[13] = 22;
        mMapInitXOfECellColm[14] = 23;
        mMapInitXOfECellColm[15] = 26;
        mMapInitXOfECellColm[16] = 27;
        mMapInitXOfECellColm[17] = 28;
        mMapInitXOfECellColm[18] = 47;
        mMapInitXOfECellColm[19] = 48;
        mMapInitXOfECellColm[20] = 49;
        mMapInitXOfECellColm[21] = 52;
        mMapInitXOfECellColm[22] = 53;
        mMapInitXOfECellColm[23] = 54;
        mMapInitXOfECellColm[24] = 57;
        mMapInitXOfECellColm[25] = 58;
        mMapInitXOfECellColm[26] = 59;
        mMapInitXOfECellColm[27] = 62;
        mMapInitXOfECellColm[28] = 63;
        mMapInitXOfECellColm[29] = 64;
        mMapInitXOfECellColm[30] = 67;
        mMapInitXOfECellColm[31] = 68;
        mMapInitXOfECellColm[32] = 69;
        mMapInitXOfECellColm[33] = 72;
        mMapInitXOfECellColm[34] = 73;
        mMapInitXOfECellColm[35] = 74;

        sECMapXToColmNum[1] =  0;
        sECMapXToColmNum[2] =  1;
        sECMapXToColmNum[3] =  2;
        sECMapXToColmNum[6] =  3;
        sECMapXToColmNum[7] =  4;
        sECMapXToColmNum[8] =  5;
        sECMapXToColmNum[11] = 6;
        sECMapXToColmNum[12] = 7;
        sECMapXToColmNum[13] = 8;
        sECMapXToColmNum[16] = 9;
        sECMapXToColmNum[17] = 10;
        sECMapXToColmNum[18] = 11;
        sECMapXToColmNum[21] = 12;
        sECMapXToColmNum[22] = 13;
        sECMapXToColmNum[23] = 14;
        sECMapXToColmNum[26] = 15;
        sECMapXToColmNum[27] = 16;
        sECMapXToColmNum[28] = 17;
        sECMapXToColmNum[47] = 18;
        sECMapXToColmNum[48] = 19;
        sECMapXToColmNum[49] = 20;
        sECMapXToColmNum[52] = 21;
        sECMapXToColmNum[53] = 22;
        sECMapXToColmNum[54] = 23;
        sECMapXToColmNum[57] = 24;
        sECMapXToColmNum[58] = 25;
        sECMapXToColmNum[59] = 26;
        sECMapXToColmNum[62] = 27;
        sECMapXToColmNum[63] = 28;
        sECMapXToColmNum[64] = 29;
        sECMapXToColmNum[67] = 30;
        sECMapXToColmNum[68] = 31;
        sECMapXToColmNum[69] = 32;
        sECMapXToColmNum[72] = 33;
        sECMapXToColmNum[73] = 34;
        sECMapXToColmNum[74] = 35;
      }

      int type;
      for (int i=0; i<92; i++)
      {
        type = -1;
        if (sECMapXToColmNum.find(i) != sECMapXToColmNum.end())
          type = 0;
        else if (sEDMapXToColmNum.find(i) != sEDMapXToColmNum.end())
          type = 1;
        else if (i >= 30 && i < 46)
          type = 3;
        else if (i >= 76 && i < 92)
          type = 2;
        assert(-1 != type);

        for (int j=0; j<64; j++)
        {
          assert(false == vecBool[i][j].isOccupied);
          vecBool[i][j].cellType = type;
        }
      }
      
      assert(mMapInitXOfDffColm[0] == 0);
      assert(mMapInitXOfECellColm[0] == 1);

      mClkIdInEachColm.resize(24);
      std::fill(mClkIdInEachColm.begin(), mClkIdInEachColm.end(), -1);
    }

  public: // All non-const functions.
    // Add a node to the tile.  The implementation adds the node
    // to the correct vector based on the type of the node passed.
    void AddNode(CNode *tmpNode);

    // Remove the node tmpNode from this tile
    void RemoveNode(const CNode *tmpNode);

    // Remove all the nodes which are in vector v from this tile
    void RemoveNodes(const vector<CNode *>& v);

    // Legalize this tile.  Legalize function first makes a call
    // to IsDensityOK() functions to see if at all the Tile
    // can be legalized.  If so, it legalizes it.
    bool Legalize();

  public:  // All const functions.  No data structure modified

    // Ask question whether this tile can accept the node tmpNode in
    // it.  Based on the type of tmpNode, a check is performed based
    // on the current size of various arrays to see if there is
    // capacity left in them.
    bool CanTake(CNode *tmpNode) const;

    // Same as above, but checks if a cell of type aType can be accepted
    // in this tile or not.  A typical use would be to check if more
    // brams can be put in this tile.  In such a case, call CanTake(3);
    bool CanTake(int   aType) const;

    // Returns the state of density in the tile.  Basically only of the
    // number of ecell/dff/bram/regs is less than the maximum that can
    // come in it, then only true is returned.
    bool IsDensityOK(int aType = -1) const;
    int getCapacity(int aType = -1) const;

    // Returns whether the design is already legal or not.  First checks
    // if the tile is dirty - meaning that something has been added to
    // it after legalization was last performed.  If it is dirty, the
    // design is not legal.
    bool IsLegal() const;

    // Get a vector containing the IDs of the clocks which are in this
    // tile.  The IDs are integers.  If needed the string name of the
    // clock can be had using the map defined in Design.h as
    // map<string, int> mMapClockDomainNameToInt using the clock IDs
    vector<int>& GetClockIdsInside() const;

    int ExtraOfType(int aType) const;

    // Clear all the vectors and private members of the class
    void Clear();

    // Given that the placement of the edff and ecell is done, call
    // AssignCellsToColumns() to put the cells into correct columns.
    void AssignCellsToColumns();

    // Front-end for running linear placement on each column of the tile
    void LinearPlacement();

    // Front-end for local reordering within each column of this tile
    void LocalReordering();

    void RemoveBRAM();
    void RemoveRegFiles();

    void WriteImage(string fileBaseName);
    // Get the number of cells inside this tile
    int NumCellsInside() const
    {
      return (mECells.size() + mDffs.size() + mRegs.size() + mBrams.size());
    }

    bool operator<(const CTile& other);

    double X() const
    {
      return mX;
    }
    double Y() const
    {
      return mY;
    }
    void   X(double aX)
    {
      mX = aX;
    }
    void   Y(double aY)
    {
      mY = aY;
    }

    bool Contains(CNode* aNode) const;
    void Anneal(double aMinSuccessRatio = 0.05);

  private:
    bool IsClockAcceptable(CNode *aNode) const;

  private:
    // ECell legalization/Optimization functions
    void assignECellsToBestColumn(double xOff, double yOff, bool bIsFinalAssign = false);
    // Dff legalization/Optimization functions
    void assignEDffsToBestColumn(double xOf, double yOf, bool bIsFinal = false);
    void linearPlaceColumn(vector <CNode*>& v);
    void localReorder(vector <CNode*>& v);
    void localReorderUp(int x);
    void localReorderDown(int x);

    void removeFromVec(vector<CNode*>& v, const CNode* aNode);
    bool intersectsWithRectangle(double, double, double, double) const;


  public:
    map <int, int> mMapECellsOfClkType;
    map <int, int> mNumCellsOfClk;
    vector<int> mBramsClks;
    vector<int> mRegsClks;

    vector <CNode*> mECells;
    vector <CNode*> mDffs;
    vector <CNode*> mRegs;
    vector <CNode*> mBrams;

    vector< vector<CNode*> > mColumnsEDff;
    vector< vector<CNode*> > mColumnsECell;

    bool mIsLegal;
    bool mIsDirty;

  public:
    double mX;
    double mY;
    int mTileId;

  public:
    bool operator==(const CTile &other) const
    {
      return (
               fabs(mX - other.mX) < DBL_ZERO_ABS &&
               fabs(mY - other.mY) < DBL_ZERO_ABS);
    }

    bool operator!=(const CTile &other) const
    {
      return !(*this == other);
    }

    int NumColumnReqd() const;

    friend std::ostream& operator<<(std::ostream& s, const CTile& t)
    {
      s << "Tile x/y=( " << t.X() << "/" << t.Y() << " ) #cells=( " <<
      t.mECells.size() << " " << t.mDffs.size() << " " <<
      t.mRegs.size() << " " << t.mBrams.size() << " ) #clks=( " <<
      t.mNumCellsOfClk.size() << " )";
      return s;
    }

    public:
    vector< vector<InfoAt> >vecBool;

    bool PutAt(int x, int y, CNode *n);
    CNode *RemoveFrom(int x, int y, CNode *n);

    bool& isOccupied(int x, int y) { return vecBool[x][y].isOccupied; }
    int   typeAtLocation(int x, int y) { return vecBool[x][y].cellType; }

    void LegalizeToClosestPosition(vector <CNode *>& v);
    void LegalizeDffsToClock();
    bool rotateAndPlace(CNode *n, int x, int y);
    void findClocksForColumn();
    void initializeClocks();
    void legalizeDffsUsingClocksForColumns();
    bool rotateAndPlaceWithClock(CNode *n, int x, int y);
    void checkIfLegalityInThisTileOK();
    void CheckECellAndDffPosnLegality();

    vector<int> mClkIdInEachColm;
};

#endif
