/*
***********************************************************************
LICENSE AGREEMENT
***********************************************************************
 READ THIS LICENSE AGREEMENT CAREFULLY BEFORE USING THIS PRODUCT. BY 
 USING THIS PRODUCT YOU INDICATE YOUR ACCEPTANCE OF THE TERMS OF THE 
 FOLLOWING AGREEMENT. THESE TERMS APPLY TO YOU AND ANY SUBSEQUENT 
 LICENSEE OF THIS PRODUCT.

               License Agreement for RegularPlace 1.0

Copyright (c)  2008 by 
Ashutosh Chakraborty, Anurag Kumar, David Z. Pan
All rights reserved

ATTRIBUTION ASSURANCE LICENSE
Redistribution of the any code, with or without modification, are permitted 
provided that the conditions below are met. These conditions require a 
modest attribution to Ashutosh Chakraborty, Anurag Kumar and Dr. 
David Z. Pan (the "Author").

1. Redistributions of any code, with or without modification (the "Code"), 
must be accompanied by any documentation and, each time the resulting 
executable program or a program dependent thereon is launched, a 
prominent display (e.g., splash screen or banner text) of the Author's 
attribution information, which includes:
  (a) Ashutosh Chakraborty, Anurag Kumar, and Dr. David Z. Pan ("AUTHOR"),
  (b) The University of Texas at Austin ("PROFESSIONAL IDENTIFICATION"), and
  (c) http://www.cerc.utexas.edu/utda/ ("URL").

2. Use is limited to academic research groups only. Users who are interested 
in industry or commercial purposes must notify Author and request 
separate license agreement.  

3. Neither the name nor any trademark of the Author may be used to 
endorse or promote products derived from this software without specific 
prior written permission.

4. Users are entirely responsible, to the exclusion of the Author and 
any other persons, for compliance with (a) regulations set by owners or 
administrators of employed equipment, (b) licensing terms of any other 
software, and (c) local, national, and international regulations regarding 
use, including those regarding import, export, and use of encryption software. 

THIS FREE SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE AUTHOR OR ANY CONTRIBUTOR BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, EFFECTS OF UNAUTHORIZED OR MALICIOUS NETWORK 
ACCESS; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY 
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include <iostream>
#include <cfloat>
#include <map>

#include "math.h"

#include "Util.h"
#include "Design.h"
#include "Data.h"
#include "Tile.h"

using namespace std;

#undef _VERBOSE
// #define _VERBOSE

void CTile::assignECellsToBestColumn(double xOff, double yOff, bool bIsFinalAssign)
{
  for (int i = 0; i < mColumnsECell.size(); i++)
    mColumnsECell[i].clear();

  vector <int> posnFilledInColm(mColumnsECell.size());
//   posnFilledInColm.clear();
  for (int i = 0; i < posnFilledInColm.size(); i++)
    posnFilledInColm[i] = 0;

  // Sort all nodes according to the y cordinate
  int oldSize = mECells.size();
  sort(mECells.begin(), mECells.end(), cmpNodes);
  assert(oldSize == mECells.size());

  for (int i = 0; i < mECells.size(); i++)
  {
    CNode* tmp = mECells[i];

    // Find where this cell should go (index at bestIdx)
    int bestIdx = -1;
    double bestCost = DBL_MAX;
    double cost;
    for (int j = 0; j < mColumnsECell.size(); j++)
    {
      cost = -1.0;

      if (posnFilledInColm[j] == gMaxColmHeight)
        continue;
      tmp->PutAt(xOff + mMapInitXOfECellColm[j], yOff + posnFilledInColm[j]);
      cost = tmp->GetIncidentWL();
      assert(-1.0 != cost);
      if (cost < bestCost)
      {
        bestCost = cost;
        bestIdx = j;
      }
    }
    if (-1 == bestIdx)
    {
      cout << "i is " << i << endl;
      exit(1);
    }
    assert(-1 != bestIdx);
    assert(bestCost < DBL_MAX);

    // Put at bestIdx location.
    tmp->PutAt(xOff + mMapInitXOfECellColm[bestIdx], yOff + posnFilledInColm[bestIdx]);
    posnFilledInColm[bestIdx]++;

#ifdef _VERBOSE
    cout << "for index " << bestIdx  << " posnFilledInColm = " << posnFilledInColm[bestIdx] << endl;
    cout << mMapInitXOfECellColm[0] << "  " << mMapInitXOfECellColm[2] << endl;
#endif

    if (bIsFinalAssign)
    {
      mColumnsECell[bestIdx].push_back(tmp);
      assert(mColumnsECell[bestIdx].size() == posnFilledInColm[bestIdx]);
    }
  }

#ifdef _VERBOSE
  for (int i = 0; i < mECells.size(); i++)
    cout << *(mECells[i]) << endl;
#endif
}
