#ifndef _FLOWSOLVER_H_
#define _FLOWSOLVER_H_

#include "ABKCommon/sgi_hash_map.h"
#include "ABKCommon/abkcommon.h"
#include "cs2.h"

typedef hash_map< std::pair< unsigned long, unsigned long >, std::pair< long, long >,
hash< std::pair< unsigned long, unsigned long > >,
std::equal_to< std::pair< unsigned long, unsigned long > > > edgeHashMap;

class flowSolver
{
private:
  long  _numFlowNodes;
  long  _numFlowEdges;
  price_t _m_c;
  node *_nodes;
  arc  *_arcs;
  long *_cap;

public:

  flowSolver();
  ~flowSolver();
  void initProblem(long numFlowNodes, long numFlowEdges, long unlimited,
                   unsigned long sourceId, unsigned long sinkId,
                   edgeHashMap *directedEdges, MaxMem *maxMem);
  void clearProblem();
  void solve();
  price_t getPrice(unsigned long nodeId) const;
  void setPrice(unsigned long nodeId, price_t price);
};

#endif
